#!/usr/bin/perl
use Mysql;

#    ADCenter SQL v1.7 - ads management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

######################################################################
# Variables Section                                                  #
######################################################################
# Reading variables from file
open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
$methods=qq~<option value=genset>General settings</option>
<option value=genstat>General stats</option>
<option value=usrman selected>Users management</option>
<option value=banman>Banners management</option>
<option value=user>Userlist</option>
<option value=html>HTML code</option>
~;
$methods.=qq~<option value=zone>Zone management</option>\n~ if ($zoneflag);
binmode STDIN;
read (STDIN,$buf,$ENV{CONTENT_LENGTH});

# Parse data
($boundary)=$ENV{CONTENT_TYPE}=~/boundary="([^"]+)"/; #";
($boundary)=$ENV{CONTENT_TYPE}=~/boundary=(\S+)/ unless $boundary;
$boundary="--".$boundary;
@file=split("\r\n$boundary",$buf);
foreach (@file)
{
	s/\r\n\r\n/delimeter/;
}
($field,$data{name})=split("delimeter",$file[0]);
($field,$data{password})=split("delimeter",$file[1]);
($field,$name)=split("delimeter",$file[2]);
($field,$ban)=split("delimeter",$file[3]);
($field,$file)=split("delimeter",$file[4]);
$encline=crypt($data{name},$data{name}).":".crypt($data{password},$data{password});
&errauth if ($encline ne "$alogin:$apassword");
$sth=$dbh->query("LOCK TABLES adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT bid FROM adc_banners WHERE (uid=$name AND bid=$ban)");
$bid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($bid)
{
	push (@errors, "Banner with ID=$ban is not exist");
	&closedb;
	open (FL, "<$adcpath/template/error.tpl");
	@htmlpage=<FL>;
	close (FL);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($file=~/GIF/)
{
	$eex="gif";
	unlink ("$adcpath/banners/$ban.jpg");
	open (F,">$adcpath/banners/$ban.gif");
	binmode F;
	print F $file;
	close (F);
	&closedb;
	open (FL, "<$adcpath/template/asucupl.tpl");
	@htmlpage=<FL>;
	close (FL);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($file=~/JFIF/)
{
	$eex="jpg";
	unlink ("$adcpath/banners/$ban.gif");
	open (F,">$adcpath/banners/$ban.jpg");
	binmode F;
	print F $file;
	close (F);
	&closedb;
	open (FL, "<$adcpath/template/asucupl.tpl");
	@htmlpage=<FL>;
	close (FL);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&closedb;
push (@errors, "Your banner must be a GIF or JPG");
open (FL, "<$adcpath/template/error.tpl");
@htmlpage=<FL>;
close (FL);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;

sub errauth
{
	&closedb;
	open (F,"<$adcpath/template/errauth.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub closedb
{
$sth="";
$dbh="";
}
