#!/usr/bin/perl
use Mysql;

#    ADCenter SQL v1.7 - ads management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

######################################################################
# Variables Section                                                  #
######################################################################
# Reading variables from file
open (F, "<adc.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
######################################################################
# Main Section                                                       #
######################################################################
# Get data
$delay=$delay*60;
if ($delay)
{
	($day,$nmonth,$ndate,$time,$nyear)=split(" ",scalar localtime(time+$delay));
	$ndate="$nyear-$cal{$nmonth}-$ndate $time";
	($day,$month,$date,$time,$year)=split(" ",scalar localtime);
	$date="$year-$cal{$month}-$date $time";
	$sth=$dbh->query("LOCK TABLES adc_clock WRITE") if ($locktables);
	$sth=$dbh->query("SELECT cid FROM adc_clock WHERE ip='$ENV{REMOTE_ADDR}'");
	$cid=$sth->fetchrow;
	if ($cid)
	{
		$sth=$dbh->query("SELECT cid FROM adc_clock WHERE (ip='$ENV{REMOTE_ADDR}' AND ldate<'$date')");
		$cid2=$sth->fetchrow;
		if ($cid2==$cid)
		{
			$cancount=1;
			$sth=$dbh->query("UPDATE adc_clock SET ldate='$ndate' WHERE cid=$cid");
		}
	}
	else
	{
		$cancount=1;
		$sth=$dbh->query("INSERT INTO adc_clock (ip,ldate) VALUES ('$ENV{REMOTE_ADDR}','$ndate')");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
else
{
	$cancount=1;
}
@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
($cookie{adcuserurlx},$cookie{adcuserbanx})=split("&",$ENV{QUERY_STRING});
if ($cookie{adcuserbanx} eq "")
{
	$spot=$cookie{adcuserurlx};
	$temp="adcuserurl$spot";
	$cookie{adcuserurl}=$cookie{$temp};
	$temp="adcuserban$spot";
	$cookie{adcuserban}=$cookie{$temp};
}
else
{
	$cookie{adcuserurl}=$cookie{adcuserurlx};
	$cookie{adcuserban}=$cookie{adcuserbanx};
}
($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$month=$cal{$month};
$month="0".$month if (length($month)==1);
$date="0".$date if (length($date)==1);
$expdate="$year-$month-$date";
($hours)=split(":",$time);
$field="h$hours";
$time=~s/://g;
#p0ST sTATiSTiCS
if ($cancount)
{
	$sth=$dbh->query("LOCK TABLES adc_clc WRITE") if ($locktables);
	$sth=$dbh->query("SELECT sid FROM adc_clc WHERE (uid=$cookie{adcuserurl} AND bid=$cookie{adcuserban} AND statd='$expdate')");
	$sid=$sth->fetchrow;
	unless ($sid)
	{
		$sth=$dbh->query("INSERT INTO adc_clc (uid,bid,statd,h00,h01,h02,h03,h04,h05,h06,h07,h08,h09,h10,h11,h12,h13,h14,h15,h16,h17,h18,h19,h20,h21,h22,h23) VALUES ($cookie{adcuserurl},$cookie{adcuserban},'$expdate',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)");
	}
	$sth=$dbh->query("UPDATE adc_clc SET $field=$field+1 WHERE (uid=$cookie{adcuserurl} AND bid=$cookie{adcuserban} AND statd='$expdate')");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	if ($creditsystem)
	{
		$sth=$dbh->query("LOCK TABLES adc_users WRITE") if ($locktables);
		$sth=$dbh->query("UPDATE adc_users SET ccred=ccred-1 WHERE (uid=$cookie{adcuserurl} AND ccred>1)");
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	}
}

# Redirect
$sth=$dbh->query("LOCK TABLES adc_banners READ") if ($locktables);
$sth=$dbh->query("SELECT url FROM adc_banners WHERE (uid=$cookie{adcuserurl} AND bid=$cookie{adcuserban})");
$uurl=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "Location: $uurl\n\n";

sub closedb
{
$sth="";
$dbh="";
}
